<?php
/**
 * GlobalBases_AutoInvoice_Model_Order_Payment
 *
 * @category    GlobalBases
 * @package     GlobalBases_AutoInvoice
 * @copyright   Copyright (c) 2013 GlobalBases.com GmbH (http://www.globalbases.com)
 * @license     http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 * @author     	GlobalBases.com GmbH <http://www.globalbases.com>
 */ 

class GlobalBases_AutoInvoice_Model_Order_Payment extends Mage_Sales_Model_Order_Payment 

{
    public function registerCaptureNotification($amount, $skipFraudDetection = false)
    {
		$autocreate = Mage::getStoreConfig('invoiceconfig/autocreate/active');  // Configvalue to enable generating invoice
        $ordermail = Mage::getStoreConfig('invoiceconfig/autocreate/ordermail');

        $this->_generateTransactionId(Mage_Sales_Model_Order_Payment_Transaction::TYPE_CAPTURE,
            $this->getAuthorizationTransaction()
        );

        $order   = $this->getOrder();
        $amount  = (float)$amount;
        $invoice = $this->_getInvoiceForTransactionId($this->getTransactionId());

        // register new capture
        if (!$invoice) {
            if ($this->_isCaptureFinal($amount)) {
				if( $autocreate ) { // Enable generating invoice
					$invoice = $order->prepareInvoice()->register();
					$order->addRelatedObject($invoice);
					$this->setCreatedInvoice($invoice);
				}
            } else {
                $this->setIsFraudDetected(true);
                $this->_updateTotals(array('base_amount_paid_online' => $amount));
            }
        }

        $status = true;
        if ($this->getIsTransactionPending()) {
            $message = Mage::helper('sales')->__('Capturing amount of %s is pending approval on gateway.', $this->_formatPrice($amount));
			if( $autocreate ) {
				$state = Mage_Sales_Model_Order::STATE_PAYMENT_REVIEW;  // if invoice is autogenerated
			} else {
				$state = Mage_Sales_Model_Order::STATE_NEW;  // if invoice is not autogenerated
			}
            if ($this->getIsFraudDetected()) {
				$state = Mage_Sales_Model_Order::STATE_PAYMENT_REVIEW;
                $message = Mage::helper('sales')->__('Order is suspended as its capture amount %s is suspected to be fraudulent.', $this->_formatPrice($amount));
                $status = Mage_Sales_Model_Order::STATUS_FRAUD;
            }
        } else {
            $message = Mage::helper('sales')->__('Registered notification about captured amount of %s.', $this->_formatPrice($amount));
			if( $autocreate ) {
				$state = Mage_Sales_Model_Order::STATE_PROCESSING;  // if invoice is autogenerated
			} else {
				$state = Mage_Sales_Model_Order::STATE_NEW;  // if invoice is not autogenerated
			}
            if ($this->getIsFraudDetected()) {
                $state = Mage_Sales_Model_Order::STATE_PAYMENT_REVIEW;
                $message = Mage::helper('sales')->__('Order is suspended as its capture amount %s is suspected to be fraudulent.', $this->_formatPrice($amount));
                $status = Mage_Sales_Model_Order::STATUS_FRAUD;
            }
            // register capture for an existing invoice
            if ($invoice && Mage_Sales_Model_Order_Invoice::STATE_OPEN == $invoice->getState()) {
                $invoice->pay();
                $this->_updateTotals(array('base_amount_paid_online' => $amount));
                $order->addRelatedObject($invoice);
            }
        }

        $transaction = $this->_addTransaction(Mage_Sales_Model_Order_Payment_Transaction::TYPE_CAPTURE, $invoice, true);
        $message = $this->_prependMessage($message);
        $message = $this->_appendTransactionToMessage($transaction, $message);
        $order->setState($state, $status, $message);

		if( !$autocreate && !$this->getIsFraudDetected() ) {
			if( $ordermail ) {
				try {
                    $order->sendNewOrderEmail();
					$historyItem = Mage::getResourceModel('sales/order_status_history_collection')
						->getUnnotifiedForInstance($order, Mage_Sales_Model_Order::HISTORY_ENTITY_NAME);
					if ($historyItem) {
						$historyItem->setIsCustomerNotified(1);
						$historyItem->save();
					}
                } catch (Exception $e) {
                    Mage::logException($e);
                }
			}
		}	

        return $this;
    }
}
